package net.pricefx.common.apibuilder;

public abstract class BacklinkBuilder<O extends ObjectIdentity> extends ObjectIdentity {

	public static final String METHOD_BACK = "back";

	public BacklinkBuilder(String instanceId, String classId, O backLink) {
		super(instanceId, classId, backLink, backLink.idGenerator, backLink.invocations);
	}

	public final O back() {
		addInvocation(METHOD_BACK);
		return getParent();
	}
	
	@SuppressWarnings("unchecked")
	protected final O getParent() {
		return (O) parentObjectIdentity;
	}

}