package net.pricefx.common.dto;

import java.util.LinkedHashSet;

public class InsertWorkflowStepsDTO {

    private final LinkedHashSet<WorkflowDTO.StepDTO> steps = new LinkedHashSet<WorkflowDTO.StepDTO>();
    private boolean postStepLogicFailed;

    /**
     * Inserts an approval step right after workflow post logic step that is executing this code.
     * @param uniqueName Name of the step
     * @return
     */
    public WorkflowDTO.ApprovalStepDTO insertApprovalStep(String uniqueName) {
        WorkflowDTO.ApprovalStepDTO qas = new WorkflowDTO.ApprovalStepDTO(null, uniqueName);
        steps.add(qas);
        return qas;
    }

    /**
     * Inserts a watcher step right after workflow post logic step that is executing this code.
     * A watcher step cannot approve or deny, but will receive a notification when it becomes active.
     * @param uniqueName Name of the step
     * @return
     */
    public WorkflowDTO.WatcherStepDTO insertWatcherStep(String uniqueName) {
        WorkflowDTO.WatcherStepDTO ws = new WorkflowDTO.WatcherStepDTO(null, uniqueName);
        steps.add(ws);
        return ws;
    }

    //private, should not be used by consultants

    public LinkedHashSet<WorkflowDTO.StepDTO> getSteps() {
        return steps;
    }

    public boolean isPostStepLogicFailed() {
        return postStepLogicFailed;
    }

    public void setPostStepLogicFailed(boolean postStepLogicFailed) {
        this.postStepLogicFailed = postStepLogicFailed;
    }
}
